# Contributing 

Want to contribute to **swagger-stats**? Awesome!


There are many ways you can contribute:

* by using prerelease versions
* by reporting bugs
* by suggesting new features
* by writing or editing documentation
* by writing code ( no patch is too small : fix typos, add comments, clean up inconsistent whitespace )
* by closing issues
* by reviewing code

## Proposing pull requests

Pull requests are very welcome. Note that if you are going to propose drastic changes, be sure to open an issue for discussion first, to make sure that your PR will be accepted before you spend effort coding it.


Here's a quick guide for contributing:

1. Fork the repo.
1. Install dependencies: `npm install`
1. Run the tests: `npm test`
1. Add a test for your change.
1. Make the tests pass.
1. Push to your fork and submit a pull request.


Inspired by https://github.com/middleman/middleman-heroku/blob/master/CONTRIBUTING.md
